
USE SVH_REPORT_DB
GO

/*
|| Autor: Dani Bieto
|| Fecha: 2022.05.23
|| Proyecto: JUNO
|| Proceso: Actualizar la tabla MAESTRO_CARTERA, el indicador de CONTROL_CARTERA y los campos asociados a dicho indicador
*/


	--=======================================================================
	--										TEMPORALES
	--=======================================================================

	DROP TABLE IF EXISTS #TMP_SOCIEDADES

	SELECT CAMPO, 
			 VALOR AS SOCIEDAD
	  INTO #TMP_SOCIEDADES
	  FROM [JUNO].[TMP_PARAMETRICA]
	WHERE INFORME = 'SOCIEDAD'
	  AND CONCEPTO = 'KUTXABANK. PERIMETRO INMOBILIARIA'
	  AND FLAG = 1

	--=========================================================================================================================================
	--														         UPDATE CONTROL_CARTERA - MAESTRO_CARTERA
	--=========================================================================================================================================

	DECLARE @ANYOMES VARCHAR(6);
	SET @ANYOMES = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);	

	/*
	|| Fecha: 2022.08.05
	|| Autor: Jhon Reyes
	|| Motivo: Parametrizar los días de cierre, de momento son los días D+3 y D+4
	||
	|| @DIA_MAX_CIERRE: Es el día maximo del que se quieren/deben tomar los datos del historico de ur_maestro(fecha_datos).
	||							De momento se mantiene el D+4. Es decir se toman los datos del día 3. Esta variable es PARAMETRIZABLE,
	||							es decir, se puede modificar, dependiendo de la necesidad de cuando se establece como día de cierre.
	|| @DIA_DX: Día del que se van a tomar los datos del historico de ur_maestro. Este día nunca será mayor que el establecido en @DIA_MAX_CIERRE
	||			Posibles valores:
	||				Si se ejecuta el día 1: 1
	||				Si se ejecuta el día 2: 2
	||				Si se ejecuta el día 3: 3
	||				Si se ejecuta el día 4: 3
	||				...
	||				Si se ejecuta el día 30: 3		
	*/

	DECLARE @DIA_DX INT, @DIA_ACTUAL INT, @DIA_MAX_CIERRE INT
	SET @DIA_ACTUAL = DAY(GETDATE())
	SET @DIA_MAX_CIERRE = 3
	SET @DIA_DX = (SELECT CASE WHEN @DIA_ACTUAL >= @DIA_MAX_CIERRE THEN @DIA_MAX_CIERRE ELSE @DIA_ACTUAL END)	
	
	DECLARE @FECHA_FIN_DATOS VARCHAR(10); 	
	SET @FECHA_FIN_DATOS = CONVERT(VARCHAR(10),DATEADD(dd, @DIA_DX, EOMONTH(GETDATE(), -1)),121)

	/*
	|| PERÍMETRO CIERRE (SOLO STOCK)
	|| Tabla UR_PERIMETRO_CIERRE:
	||		Se carga una vez por periodo. Por lo que no tiene impacto en ejecutar N veces después del día D+4. Es decir, durante todo el mes, no se vuelve a actualizar la tabla de perimetro cierre
	||		- Para bancos el primero de cada mes
	||		- Para inmobiliarias entre el 3 y el 5 de cada mes. Tener cuidado con esto, se debe
	||			confirmar que esté cargada la tabla antes de darle al botón para el ejecución del D+4
	*/

	DROP TABLE IF EXISTS #TMP_CONTROL_CARTERA_01
	SELECT 
		  CAR.SOCIEDAD
		, CAR.UNIDAD_REGISTRAL
		, CAR.IND_CONTROL_CARTERA AS IND_CONTROL_CARTERA_OLD
		, CAR.CONTROL_CARTERA CONTROL_CARTERA_OLD
		, CAR.PROMOCION_COMERCIAL
		, '' FECHA_VENTA
		, '' FECHA_REGISTRO_BAJA
		, PERIMETRO.IND_STK_NEG
		, '01' IND_CONTROL_CARTERA_NEW
		, 'STOCK' CONTROL_CARTERA_NEW
		, '' CODIGO_ACTUACION_BAJA	
		, CAR.USR032_LITERAL_ESTADO
		, 'PERIMETRO CIERRE - STOCK' ORIGEN_PERIMETRO	
      , UR_MIG.IND_APORTACION			
		INTO #TMP_CONTROL_CARTERA_01
	FROM [JUNO].[MAESTRO_CARTERA] CAR
	INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR_MIG ON CAR.SOCIEDAD = UR_MIG.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = UR_MIG.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CAR.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN SVH_CORP_DB.DBO.UR_PERIMETRO_CIERRE PERIMETRO ON CAR.SOCIEDAD = PERIMETRO.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = PERIMETRO.UNIDAD_REGISTRAL AND CAR.PERIODO = PERIMETRO.ANYO_MES
	WHERE CAR.PERIODO = @ANYOMES
	AND PERIMETRO.IND_STK_NEG IN ('X', 'Y')
	AND UR_MIG.IND_MIGRACION = 'X'


	/*
	|| PERÍMETRO RESTO: BAJA y VENTA
	*/

	DROP TABLE IF EXISTS #TMP_CONTROL_CARTERA_02
	SELECT 
		  CAR.SOCIEDAD
		, CAR.UNIDAD_REGISTRAL
		, CAR.IND_CONTROL_CARTERA AS IND_CONTROL_CARTERA_OLD
		, CAR.CONTROL_CARTERA CONTROL_CARTERA_OLD
		, CAR.PROMOCION_COMERCIAL
		, UR.FECHA_VENTA
		, UR.FECHA_REGISTRO_BAJA
		, UR.IND_STK_NEG
		, CASE 
			WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_VENTA_REALIZADA = 'X' THEN 'E02'
			WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_BAJA_REALIZADA  = 'X' THEN 'E03'
			WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN '01'
			WHEN UR.IND_VENTA_REALIZADA = 'X'  THEN '02'
			WHEN UR.IND_BAJA_REALIZADA  = 'X'  THEN '03'
			ELSE 'E99'
		  END AS IND_CONTROL_CARTERA_NEW
		, CASE 
			WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN 'STOCK'
			WHEN UR.IND_VENTA_REALIZADA = 'X' THEN 'VENTA'
			WHEN UR.IND_BAJA_REALIZADA  = 'X' THEN 'BAJA'
			ELSE 'ERROR. DESCONOCIDO'
		  END CONTROL_CARTERA_NEW
		, UR.CODIGO_ACTUACION_BAJA	
		, CAR.USR032_LITERAL_ESTADO
		, 'UR MAESTRO HIST - NO STOCK' ORIGEN_PERIMETRO
		, UR_MIG.IND_APORTACION
		INTO #TMP_CONTROL_CARTERA_02
	FROM [JUNO].[MAESTRO_CARTERA] CAR
	INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR_MIG ON CAR.SOCIEDAD = UR_MIG.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = UR_MIG.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CAR.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN [SVH_CORP_DB].[HISTORICO].[UR_MAESTRO] UR ON CAR.SOCIEDAD = UR.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	WHERE CAR.PERIODO = @ANYOMES 
	AND UR_MIG.IND_MIGRACION = 'X'
	AND UR.FECHA_DATOS = @FECHA_FIN_DATOS
	AND NOT EXISTS(SELECT 'X' FROM #TMP_CONTROL_CARTERA_01 TMP WHERE TMP.SOCIEDAD = CAR.SOCIEDAD AND TMP.UNIDAD_REGISTRAL = CAR.UNIDAD_REGISTRAL)


	--=======================================================================================
	--	  Tabla temporal que contiene el campo control_cartera actualizado a día D+4
	--=======================================================================================

	DROP TABLE IF EXISTS #TMP_CONTROL_CARTERA 
	
	SELECT Z.* INTO #TMP_CONTROL_CARTERA 
	FROM(
		SELECT * FROM #TMP_CONTROL_CARTERA_01
		UNION ALL
		SELECT * FROM #TMP_CONTROL_CARTERA_02
		)Z

--=========================================================================================================================================
--						         OTROS PROCESOS. ACTUALIZAR CAMPOS DEPENDIENTES DEL CAMBIO DE CONTROL_CARTERA
--=========================================================================================================================================
	
	DROP TABLE IF EXISTS #TMP_JUNO_CONDICIONES_PRECIOS

	SELECT Z.* INTO #TMP_JUNO_CONDICIONES_PRECIOS
	FROM(
		SELECT
			 CP.SOCIEDAD
		  , CP.UNIDAD_REGISTRAL
		  , CP.FECHA_INI_VALIDEZ
		  , CP.FECHA_CREACION
		  , CP.CLASE_CONDICION
		  , CP.IMPORTE
		  , CP.FECHA_FIN_VALIDEZ
		  , CP.IND_BORRADO
		  , CARTERA.CONTROL_CARTERA_NEW
		  , MAX(CP.FECHA_INI_VALIDEZ) OVER(PARTITION BY CP.SOCIEDAD, CP.UNIDAD_REGISTRAL) FECHA_INI_VALIDEZ_MAX
		FROM [SVH_CORP_DB].[dbo].[CONDICIONES_PRECIOS] CP
		INNER JOIN #TMP_CONTROL_CARTERA CARTERA ON CP.SOCIEDAD = CARTERA.SOCIEDAD AND CP.UNIDAD_REGISTRAL = CARTERA.UNIDAD_REGISTRAL
		) Z
	WHERE FECHA_INI_VALIDEZ = FECHA_INI_VALIDEZ_MAX

	DROP TABLE IF EXISTS #TMP_JUNO_CONDICIONES_PRECIOS_FINAL

	SELECT 
		 SOCIEDAD
	  , UNIDAD_REGISTRAL
	  , IMPORTE
	  , CONTROL_CARTERA_NEW
	  INTO #TMP_JUNO_CONDICIONES_PRECIOS_FINAL 
	FROM #TMP_JUNO_CONDICIONES_PRECIOS
	WHERE YEAR(FECHA_FIN_VALIDEZ) = 9999 AND IND_BORRADO = '' AND CLASE_CONDICION IN('Z200', 'Z211')


	DROP TABLE IF EXISTS #TMP_JUNO_VENTAS_OPERATIVA

	SELECT
		 VTA.SOCIEDAD
	  , VTA.UNIDAD_REGISTRAL
	  , VTA.PRECIO_VENTA_FINAL
	  , CARTERA.CONTROL_CARTERA_NEW
		 INTO #TMP_JUNO_VENTAS_OPERATIVA
	FROM [SVH_CORP_DB].[DBO].[VENTAS_OPERATIVA] VTA
	INNER JOIN #TMP_CONTROL_CARTERA CARTERA ON VTA.SOCIEDAD = CARTERA.SOCIEDAD AND VTA.UNIDAD_REGISTRAL = CARTERA.UNIDAD_REGISTRAL
	WHERE ISNULL(VTA.VENTA_ANULADA, '') = ''
	AND VTA.FECHA_ANULACION IS NULL
	
	
	/*
	|| Fecha: 2022.07.22
	|| Autor: Jhon Reyes
	||	Modificación:
	||			- Antes, se hacia update mediante left joins
	||			- Ahora, se crea este proceso para generar en una sola tabla la data que actualizará el campo USR097.
	||	Detalle:
	||			- El campo USR097, se informa mediante dos tablas del corporativo, donde la lógica dice que si control_cartera = venta entonces gana 
	||				la tabla ventas_operativas sino condiciones_precios.
	||				Para solventar está logica de ir a dos tablas diferentes, es que se ha creado una solo tabla con la data de las 2 tablas. 
	||				Resaltar que se realiza un delete para los casos en que la UR existe tanto en ventas_operativas como en condiciones_precios.
	||				Debido a la logica del campo, el delete se realiza sobre la temporal de condiciones_precios, ya que, como hemos comentado
	||				cuando control_cartera = venta entonces gana lo que hay en la tabla ventas_operativas
	*/

	DROP TABLE IF EXISTS #TMP_JUNO_VENTAS

	SELECT VTA.*, 'VENTA_OPERATIVA' ORIGEN INTO #TMP_JUNO_VENTAS
	FROM #TMP_JUNO_VENTAS_OPERATIVA VTA
	WHERE VTA.CONTROL_CARTERA_NEW = 'VENTA'
	
	DROP TABLE IF EXISTS #TMP_JUNO_PRECIOS

	SELECT COND.*, 'CONDICIONES_PRECIOS' ORIGEN INTO #TMP_JUNO_PRECIOS
	FROM #TMP_JUNO_CONDICIONES_PRECIOS_FINAL COND
	
	
	DELETE PRECIO
	FROM #TMP_JUNO_PRECIOS PRECIO
	INNER JOIN #TMP_JUNO_VENTAS VENTA ON PRECIO.SOCIEDAD = VENTA.SOCIEDAD AND PRECIO.UNIDAD_REGISTRAL = VENTA.UNIDAD_REGISTRAL
	
	DROP TABLE IF EXISTS #TMP_JUNO_PRECIO_BRUTO_VENTA_USR097

	SELECT Z.* INTO #TMP_JUNO_PRECIO_BRUTO_VENTA_USR097
	FROM(
		SELECT * FROM #TMP_JUNO_VENTAS
		UNION ALL
		SELECT * FROM #TMP_JUNO_PRECIOS
		)Z
	
	/*
	|| UPDATE CAMPO USR097_PRECIO_BRUTO_VENTA
	*/
	
	UPDATE CARTERA
	SET CARTERA.USR097_PRECIO_BRUTO_VENTA = UPD.PRECIO_VENTA_FINAL
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
	INNER JOIN #TMP_JUNO_PRECIO_BRUTO_VENTA_USR097 UPD  ON CARTERA.SOCIEDAD = UPD.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UPD.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES


	--===================================================
	--			TEMPORAL UPDATE
	--===================================================

	DROP TABLE IF EXISTS #TMP_UPDATE

	SELECT CAR.SOCIEDAD,
			CAR.UNIDAD_REGISTRAL,
			CAR.CONTROL_CARTERA,
			CAR_NEW.CONTROL_CARTERA_NEW,
			CAR_NEW.IND_CONTROL_CARTERA_NEW,
			CASE WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'STOCK' AND CAR_NEW.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CAR_NEW.SOCIEDAD, CAR_NEW.PROMOCION_COMERCIAL, CAR_NEW.CONTROL_CARTERA_NEW) ELSE 0 END AS NUMERO_URS_STOCK_POR_PROMO_COMERCIAL,
			CASE WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'VENTA' AND CAR_NEW.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CAR_NEW.SOCIEDAD, CAR_NEW.PROMOCION_COMERCIAL, CAR_NEW.CONTROL_CARTERA_NEW) ELSE 0 END AS NUMERO_URS_VENTA_POR_PROMO_COMERCIAL,
			CASE WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'BAJA'  AND CAR_NEW.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CAR_NEW.SOCIEDAD, CAR_NEW.PROMOCION_COMERCIAL, CAR_NEW.CONTROL_CARTERA_NEW) ELSE 0 END AS NUMERO_URS_BAJA_POR_PROMO_COMERCIAL,
			CASE WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'VENTA' THEN CAR_NEW.FECHA_VENTA  WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'BAJA'  THEN CAR_NEW.FECHA_REGISTRO_BAJA ELSE ''  END AS USR026_FECHA_ULTIMA_BAJA_ULTIMA_VENTA,
			CAR_NEW.FECHA_VENTA,
			CAR_NEW.FECHA_REGISTRO_BAJA,
			CASE
				WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'VENTA' THEN '30'
				WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'BAJA' AND CAR_NEW.CODIGO_ACTUACION_BAJA IN('BPAG', 'BPSG') THEN '32'
                WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'BAJA' AND CAR_NEW.IND_APORTACION = 'X' THEN '33'
				WHEN CAR_NEW.CONTROL_CARTERA_NEW = 'BAJA' AND CAR_NEW.CODIGO_ACTUACION_BAJA NOT IN('BPAG', 'BPSG') THEN '33'
				ELSE CAR_NEW.USR032_LITERAL_ESTADO
			END USR032_LITERAL_ESTADO_CIERRE,
         CAR_NEW.CODIGO_ACTUACION_BAJA
			INTO #TMP_UPDATE
	FROM [JUNO].[MAESTRO_CARTERA] CAR
	INNER JOIN #TMP_CONTROL_CARTERA CAR_NEW ON CAR.SOCIEDAD = CAR_NEW.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = CAR_NEW.UNIDAD_REGISTRAL
    
	WHERE CAR.PERIODO = @ANYOMES AND CAR.CONTROL_CARTERA <> CAR_NEW.CONTROL_CARTERA_NEW


	--===================================================		
	--						UPDATE FINAL	
	--===================================================


	UPDATE CAR
	SET  
		  CAR.CONTROL_CARTERA								= CAR_NEW.CONTROL_CARTERA_NEW
		, CAR.IND_CONTROL_CARTERA							= CAR_NEW.IND_CONTROL_CARTERA_NEW
		, CAR.NUMERO_URS_STOCK_POR_PROMO_COMERCIAL	= CAR_NEW.NUMERO_URS_STOCK_POR_PROMO_COMERCIAL
		, CAR.NUMERO_URS_VENTA_POR_PROMO_COMERCIAL	= CAR_NEW.NUMERO_URS_VENTA_POR_PROMO_COMERCIAL
		, CAR.NUMERO_URS_BAJA_POR_PROMO_COMERCIAL		= CAR_NEW.NUMERO_URS_BAJA_POR_PROMO_COMERCIAL
		, CAR.USR026_FECHA_ULTIMA_BAJA_ULTIMA_VENTA  = CAR_NEW.USR026_FECHA_ULTIMA_BAJA_ULTIMA_VENTA 
		, CAR.FECHA_VENTA                           	= CAR_NEW.FECHA_VENTA
		, CAR.FECHA_REGISTRO_BAJA                   	= CAR_NEW.FECHA_REGISTRO_BAJA
		, CAR.USR032_LITERAL_ESTADO						= CAR_NEW.USR032_LITERAL_ESTADO_CIERRE
		, CAR.CODIGO_ACTUACION_BAJA                  = CAR_NEW.CODIGO_ACTUACION_BAJA
	FROM [JUNO].[MAESTRO_CARTERA] CAR
	INNER JOIN #TMP_UPDATE CAR_NEW ON CAR.SOCIEDAD = CAR_NEW.SOCIEDAD AND CAR.UNIDAD_REGISTRAL = CAR_NEW.UNIDAD_REGISTRAL
	WHERE CAR.PERIODO = @ANYOMES
	
	
	